/*Server Bulletin Board*/

#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<sys/types.h>
#include<sys/ipc.h>
#include<sys/msg.h>
#include<iostream.h>
#include<pthread.h>
#include"comp-scomp.cpp"

#define MSGKEYSERVICE1 120 //Chiave canale di servizio di snd
#define MSGKEYSERVICE2 121 //Chiave canale di servizio di rcv
#define MSGKEYBASE 150 //Chiave canale base 
#define LUN 1024 //Lunghezza Max dei mess. 1024 Caratteri
 
//---- Definisco la struct del messaggio ----

struct msgform
{
  int mtype;
  char mtext[LUN];
};  

struct msgctrl
{
  int mtype;
  char mtext;
};
 
//---- Vado a definire la struct che andr a caratterizzare ogni client---

struct userform
{
  int idrcv;
  int idsnd;
  pthread_t tid;
}; 


/*
 mtext=  significa tutto ok
 mtext=  corrisponde al testo dell'idrcv
 mtext=  corrisponde al testo dell'idsnd
 mtext= ! significa errore in ricezione
*/ 


int idservsnd,idservrcv;  //--- ID dei canali di servizio ---


/* Memoria Condivisa fra i thread (def. semaforo) */
struct {
        pthread_mutex_t semaforo;
} stop = {PTHREAD_MUTEX_INITIALIZER};

/*
  per occupare il semaforo si user  pthread_mutex_lock(&stop.semaforo);   
  per liberare il semaforo si user  pthread_mutex_unlock(&stop.semaforo);
*/

/*Puntatore alla banca dati*/
FILE *NotizieFile; 

typedef struct{
                char argomento[512];
	            char notizia[512];
              } Infos;

typedef char stringa[40];

//--- Dichiaro le funzioni che andr ad utilizzare ---

void *fservice(void *);
void *fclient(userform *dati_utente);

void carica(int argc,char **argv,int &TuttoOK);
void Aggiungi(FILE *NotizieFile,userform utente);
void LeggiPos(FILE *NotizieFile,userform utente);
void CercaNome(FILE *NotizieFile,userform utente);
void StampaArgomenti(FILE *NotizieFile,userform utente);
void elimina(FILE *NotizieFile,userform utente);
void reset(FILE *NotizieFile,userform utente);

//----------------------------------------------------

void main(int argc,char **argv)
{ 
   int TuttoOK=1;
   pthread_t thservice;
   
   idservsnd=msgget(MSGKEYSERVICE1,0777|IPC_CREAT|IPC_EXCL); 
   idservrcv=msgget(MSGKEYSERVICE2,0777|IPC_CREAT|IPC_EXCL);
   if (idservsnd>-1 && idservrcv>-1)
   {
    //carica in memoria il file che funge da banca dati
    carica(argc,argv,TuttoOK);
    
    /*Se tutto  a posto si
    pu iniziare a lavorare...*/ 
    if(TuttoOK!=0)
    {
     //Controllo Canale di Servizio
     pthread_create(&thservice,NULL,fservice,NULL);
 
     //aspetto che il thread di servizio finisca  
     pthread_join(thservice,NULL);

     /* Il lavoro e' concluso... */
     fclose(NotizieFile);
    }
  }
  else
  { 
   cout<<"FATAL ERROR service ch"<<endl;
  }

  //disalloco il ch di servizio creato
  msgctl(idservsnd,IPC_RMID,NULL);
  msgctl(idservrcv,IPC_RMID,NULL);
}


//--------- Costruisco la funzione associata al thread che gestisce il----
//---------              canale di sevizio                            ----

void *fservice(void *)
{
 //dichiarazione variabili:
 
 //def. tipi di msg
 msgctrl richiesta,risposta;
 msgform testo;
 //Variabile che utilizziamo per l'assegnazione degli ID
 int OffSet=0; 
 //Variabile di controllo
 int test;  
 
 int chiave1,chiave2;
 
 userform dati_utente; //Variabile che serve per appoggiare 
                      //momentaneamente i dati dell'utente
 
 cout<<"\n\n\n";				 
 cout<<"\n                   *********************";
 cout<<"\n                   ***SERVER BuBo2001***";
 cout<<"\n                   *********************";
 cout<<"\n\n\n";
 
//Il for infinito ci garantisce un controllo continuo sul canale di servizio
   
 for(;;)
 {  
  test=msgrcv(idservrcv,&richiesta,sizeof(richiesta.mtext),0,0);
  if(richiesta.mtext='')
   cout<<"\n Ho ricevuto una richiesta di connessione";
  
  if (test!= -1 && richiesta.mtext=='')
  { 
    //creo i canali di rcv e snd per l'utente
    OffSet++;
	chiave1=MSGKEYBASE+OffSet;
    dati_utente.idrcv = msgget(chiave1,0777|IPC_CREAT);
	
    OffSet++;
	chiave2=MSGKEYBASE+OffSet;
    dati_utente.idsnd = msgget(chiave2,0777|IPC_CREAT);
	
    //  --- Imposto le generalita' del client ---
    //(nella creazione del thread client passo tutta la struttura utente)
     
     pthread_create(&dati_utente.tid,NULL,fclient,(void*) &dati_utente);
     
     
     //--- Il server manda un msg di connessione avvenuta al client ---         
     risposta.mtype = 1;
     risposta.mtext='';
	 msgsnd(idservsnd,&risposta,sizeof(risposta.mtext),0);
      cout<<"\n Invio conferma di connessione avvenuta ";
	 
	 //invio all'utente i suoi dati
	 
     risposta.mtype = chiave1; //utente.idrcv;
	 risposta.mtext = '';
	 msgsnd(idservsnd,&risposta,sizeof(risposta.mtext),0);
	 cout<<"\n Ho inviato la chiave di ch "<<risposta.mtype;
     
	 //perdo tempo inutilmente...
	 int i; for(i=0;i<10000000;i++);
	 
	 risposta.mtype = chiave2; //utente.idsnd;
	 risposta.mtext = '';
     msgsnd(idservsnd,&risposta,sizeof(risposta.mtext),0);
     cout<<"\n Ho inviato la chiave di ch "<<risposta.mtype;
		 
   }
  }
}

void *fclient(userform *dati_utente)
{   
 msgctrl scelta,risposta;
 char msg[LUN];
 int test; 
 
 userform utente;
 utente.idrcv = dati_utente->idrcv;
 utente.idsnd = dati_utente->idsnd;
 utente.tid = dati_utente->tid;
 
   
 for(;;)
 { 
  test=msgrcv(utente.idrcv,&scelta,sizeof(scelta.mtext),2,0);
  cout<<flush<<"\n Ho ricevuto la scelta "<<scelta.mtext; 
  if (test==-1)
  { 
   //--Segnala l'errore di ricezione errata
   risposta.mtext= '!';
   risposta.mtype= 1;
   msgsnd(utente.idsnd,&risposta,sizeof(risposta.mtext),0);
   cout<<flush<<"\n Invio messaggio di ERRORE";
  }
  else
  {
   //--- Il server manda un msg di connessione avvenuta al client ---  
   risposta.mtype= 1;
   risposta.mtext= ''; 
   msgsnd(utente.idsnd,&risposta,sizeof(risposta.mtext),0);
   cout<<flush<<"\n Invio messaggio OK"<<risposta.mtext;
   //Gestione del messaggio scelta 

   //Funzioni implementate da adattare
  switch(scelta.mtext)
   {
    case '1':
	 cout<<flush<<"\n lancio LeggiPos(...)";
     LeggiPos(NotizieFile,utente);
     break;
    case '2':
	 cout<<flush<<"\n lancio CercaNome(...)";
     CercaNome(NotizieFile,utente);
     break;
    case '3':
	 cout<<flush<<"\n lancio StampaArgomenti(...)"; 
     StampaArgomenti(NotizieFile,utente);
	 break;
    case '4':
	 cout<<flush<<"\n lancio Aggiungi(...)";
     Aggiungi(NotizieFile,utente);  
     break;
    case '5':
	 cout<<flush<<"\n lancio elimina(...)";
     elimina(NotizieFile,utente);
     break;
    case '6':
	 cout<<flush<<"\n lancio reset(...)";
     reset(NotizieFile,utente);
     break;
    default:
	 break;
   }         
       
  }
 }
}


void carica(int argc,char **argv,int &TuttoOK)
{
    
    char NomeFile[20];

    /* Controlliamo che il programma sia
       stato chiamato correttamente     */
    switch (argc)
    {
     case 1:
     strcpy(NomeFile,"notizie.dat");
     break;
     case 2:
     strcpy(NomeFile,argv[1]);
     break;
     default:
     printf("\nUso: notebook [<nome file dat>]\n");
     TuttoOK=0;
     break;
    }

    /* Apriamo il file */
    NotizieFile=fopen(NomeFile,"a+");
    
    if (NotizieFile==NULL)
    {                     
     printf("\nErrore in apertura del file\n");
     TuttoOK=0;
    }

}


void Aggiungi(FILE *NotizieFile,userform utente) 
{
 Infos tmp;
 struttura news;
 msgform notizia;
 int test;
            
 test=msgrcv(utente.idrcv,&notizia,sizeof(notizia.mtext),3,0);
 cout<<flush<<"\n Ho ricevuto... "<<notizia.mtext;
 
 //passo e metto a rosso il semaforo 
  pthread_mutex_lock(&stop.semaforo);
  
 if(test!=-1)
 {
  strsco(notizia.mtext,news);

  tmp.argomento=news.nome1;
  tmp.notizia=news.nome2;

  fwrite(&tmp,sizeof(tmp),1,NotizieFile);
 }
 
 //metto a verde il semaforo
 pthread_mutex_unlock(&stop.semaforo);
}


void LeggiPos(FILE *NotizieFile,userform utente) 
{
 Infos tmp;
 msgform mess;
 msgctrl pos,risposta;
 int actpos=1;
 int i=0;
 //uso i tipi definiti in comp-scomp.cpp
 struttura news;
 tex nw;

 msgrcv(utente.idrcv,&pos,sizeof(pos.mtext),0,0);
 
 if(pos.mtext=='p')
 {
  //conto il numero di notizie presenti
  fseek(NotizieFile,0,SEEK_SET);
  while( !feof(NotizieFile) )
  {
	fread(&tmp,sizeof(tmp),1,NotizieFile);
	i++;
  }
  
  if(pos.mtype<=(i-1) && pos.mtype>0)
  {
   fseek(NotizieFile,0,SEEK_SET);
   while(!feof(NotizieFile)&&(actpos!=pos.mtype))
   {
	fseek(NotizieFile,sizeof(tmp),SEEK_CUR);
	actpos++;
   }
   if (actpos!=pos.mtype)
   {
    //Non ci sono sufficienti elementi
    risposta.mtype= 1;
	risposta.mtext= '!';
	msgsnd(utente.idsnd,&risposta,sizeof(risposta.mtext),0);
   }
   else
   {
    fread(&tmp,sizeof(tmp),1,NotizieFile);
	risposta.mtype= 1;
	risposta.mtext= '';
    msgsnd(utente.idsnd,&risposta,sizeof(risposta.mtext),0);
	
	news.nome1=tmp.argomento;
	news.nome2=tmp.notizia;
	strco(news,nw);
   
    mess.mtype=4;
	mess.mtext=nw;
	msgsnd(utente.idsnd,&mess,sizeof(mess.mtext),0);
   }
  }
  else
  {
   //La posizione digitata non corrisponde ad alcuna notizia!
   risposta.mtype= 1;
   risposta.mtext= '!';
   msgsnd(utente.idsnd,&risposta,sizeof(risposta.mtext),0);
  }		   
 }			   
}


void CercaNome(FILE *NotizieFile,userform utente) 
{
 msgform nome,mess;
 msgctrl risposta;
 Infos tmp;
 struttura news;
 tex nw;
 int control=0;
 int test;			 
 
 test=msgrcv(utente.idrcv,&nome,sizeof(nome.mtext),3,0);
 if(test!=-1)
 {
  //Posizionati all'inizio del file
  fseek(NotizieFile,0,SEEK_SET);
  
  while(!feof(NotizieFile) && control==0)
  {
   fread(&tmp,sizeof(tmp),1,NotizieFile);
   
   if(strcmp(tmp.argomento,nome.mtext)==0)
   {
    //Notizia trovata!
    risposta.mtype= 1;
	risposta.mtext= '';
	msgsnd(utente.idsnd,&risposta,sizeof(risposta.mtext),0);

	news.nome1=tmp.argomento;
	news.nome2=tmp.notizia;
    strco(news,nw);

	mess.mtype=4;
	mess.mtext=nw;
	msgsnd(utente.idsnd,&mess,sizeof(mess.mtext),0);
						
	control=1;
   }
  }

  if(control==0) 
  {		  
   //Nome inesistente!
   risposta.mtype= 1;
   risposta.mtext= '!';
   msgsnd(utente.idsnd,&risposta,sizeof(risposta.mtext),0);
  }
 }
}


void elimina(FILE *NotizieFile,userform utente) 
{
 msgctrl pos,risposta;
 FILE *FileTemp;
 char ft[20];
 Infos tmp;
 int i=0; 
 int j=1;
 
 msgrcv(utente.idrcv,&pos,sizeof(pos.mtext),0,0);
 
 //passo e metto a rosso il semaforo 
 pthread_mutex_lock(&stop.semaforo);
   
 if(pos.mtext=='p')
 {
  //conto il numero di notizie presenti
  fseek(NotizieFile,0,SEEK_SET);
  while( !feof(NotizieFile) )
  {
   fread(&tmp,sizeof(tmp),1,NotizieFile);
   i++;
  }
  
  if(pos.mtype<=(i-1) && pos.mtype>0)
  {
   strcpy(ft,"temp.dat");
   FileTemp=fopen(ft,"a+");

   fseek(NotizieFile,0,SEEK_SET);
   fseek(FileTemp,0,SEEK_SET);
   while( !feof(NotizieFile) && j<i )
   {
	if(j==pos.mtype)
	{
	 fread(&tmp,sizeof(tmp),1,NotizieFile);
	 //Notizia cancellata!
     risposta.mtype= 1;
	 risposta.mtext= '';
     msgsnd(utente.idsnd,&risposta,sizeof(risposta.mtext),0);
	}
	else
	{
	 fread(&tmp,sizeof(tmp),1,NotizieFile);
     fwrite(&tmp,sizeof(tmp),1,FileTemp);
	}
	j++;
   }
   
   fclose(NotizieFile);
   remove("notizie.dat");
   fclose(FileTemp);

   rename("temp.dat","notizie.dat");

   strcpy(ft,"notizie.dat");
   NotizieFile=fopen(ft,"a+");
  }
  
  else
  {
   //La posizione digitata non corrisponde ad alcuna notizia!
   risposta.mtype= 1;
   risposta.mtext= '!';
   msgsnd(utente.idsnd,&risposta,sizeof(risposta.mtext),0);
  }				   
 }
 
 //metto a verde il semaforo
 pthread_mutex_unlock(&stop.semaforo);
}


void StampaArgomenti(FILE *NotizieFile,userform utente) 
{
  int i=1;
  int j=1;
  Infos tmp;
  msgform m;
  msgctrl risposta;
  m.mtype=3;
  strcpy(m.mtext,"");

  fseek(NotizieFile,0,SEEK_SET);
  //conta del numero di argomenti presenti (=i-1)
  while( !feof(NotizieFile) )
  {
   fread(&tmp,sizeof(tmp),1,NotizieFile);
   i++;
  }
  fseek(NotizieFile,0,SEEK_SET);
  
  while( !feof(NotizieFile) && j<(i-1) )
  {
    fread(&tmp,sizeof(tmp),1,NotizieFile);
	strcat(m.mtext,tmp.argomento);
	strcat(m.mtext,"|");
	j++;
  }
  strcat(m.mtext,"|");
  
  if(j==1) //Memoria vuota
  {
   risposta.mtype= 1;
   risposta.mtext= '!';
   msgsnd(utente.idsnd,&risposta,sizeof(risposta.mtext),0);
   cout<<flush<<"\n 3) ho risposto... "<<risposta.mtext;
  }

  else //Memoria non vuota
  {
   risposta.mtype= 1;
   risposta.mtext= '';
   msgsnd(utente.idsnd,&risposta,sizeof(risposta.mtext),0);
   cout<<flush<<"\n 3) ho risposto... "<<risposta.mtext;
   //invio argomenti
   msgsnd(utente.idsnd,&m,sizeof(m.mtext),0);
   cout<<flush<<"\n 3) ho inviato... "<<m.mtext;
   
  }
	  
}


void reset(FILE *NotizieFile,userform utente) 
{
 msgctrl scelta,risposta;
 char local[20];
 
 //passo e metto a rosso il semaforo 
 pthread_mutex_lock(&stop.semaforo);
 
   cout<<"\n resetto la banca dati"<<endl;
   fclose(NotizieFile);
   remove("notizie.dat");
   strcpy(local,"notizie.dat");
   NotizieFile=fopen(local,"a+");
   
   risposta.mtype= 1;
   risposta.mtext= '';
   msgsnd(utente.idsnd,&risposta,sizeof(risposta.mtext),0);
   cout<<flush<<"\n Ho resettato la banca dati";
 
 //metto a verde il semaforo
 pthread_mutex_unlock(&stop.semaforo);
}
